variables:
  PYTHON3_IMAGE: python:3-alpine3.13

stages:
  - syntax
  - sast
  - unittests

PyCodeStyle:
  image: $PYTHON3_IMAGE
  stage: syntax
  script:
    - pip install -r requirements.txt
    - pycodestyle app.py

Pylint:
  image: $PYTHON3_IMAGE
  stage: syntax
  script:
    - pip install -r requirements.txt
    - pylint app.py

Static Code Analysis Tests:
  stage: sast
  image: $PYTHON3_IMAGE
  script:
    - pip install -r requirements.txt
    - pip install bandit 
    - bandit app.py

Launch Unit Tests:
  stage: unittests
  image: $PYTHON3_IMAGE
  script:
    - pip install -r requirements.txt
    - python -m pytest --junit-xml=pytest-report.xml